/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
	// Application Constructor
	initialize: function() {
		this.bindEvents();
	},
	// Bind Event Listeners
	//
	// Bind any events that are required on startup. Common events are:
	// 'load', 'deviceready', 'offline', and 'online'.
	bindEvents: function() {
		document.addEventListener('deviceready', this.onDeviceReady, false);
		
	},
	// deviceready Event Handler
	//
	// The scope of 'this' is the event. In order to call the 'receivedEvent'
	// function, we must explicitly call 'app.receivedEvent(...);'
	byte2Hex: function(bytes) {
	  return bytes.map(function(byte) {
	    return (byte & 0xFF).toString(16)
	  }).join('')
	},
	ab2str: function(buf) {
	  return String.fromCharCode.apply(null, new Uint16Array(buf));
	},
	str2ab: function(str) {
	  var buf = new ArrayBuffer(str.length*2); // 2 bytes for each char
	  var bufView = new Uint16Array(buf);
	  for (var i=0, strLen=str.length; i<strLen; i++) {
	    bufView[i] = str.charCodeAt(i);
	  }
	  return buf;
	},
	hexToBytes: function (hex) {
	    for (var bytes = [], c = 0; c < hex.length; c += 2)
	    bytes.push(parseInt(hex.substr(c, 2), 16));
	    return bytes;
	},

	// Convert a byte array to a hex string
	bytesToHex: function (bytes) {
	    for (var hex = [], i = 0; i < bytes.length; i++) {
	        hex.push((bytes[i] >>> 4).toString(16));
	        hex.push((bytes[i] & 0xF).toString(16));
	    }
	    return hex.join("");
	},
	onDeviceReady: function() {
		try{
			
		
		app.receivedEvent('deviceready');
		var rfidsuccess = function(message) {
			document.getElementById("deviceready").querySelector('.asr_rf_poweron').setAttribute('style', 'display:block;');
		}
		var barcodesuccess = function(message) {
			document.getElementById("deviceready").querySelector('.asr_bc_poweron').setAttribute('style', 'display:block;');
		}

		var rfidfailure = function() {
			document.getElementById("deviceready").querySelector('.asr_rf_poweron').setAttribute('style', 'display:none;');
		}
		var barcodefailure = function() {
			document.getElementById("deviceready").querySelector('.asr_bc_poweron').setAttribute('style', 'display:none;');
		}
		
		var barcodeReceived = function(barcode){
			try{
			 document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setBarcodeStringListener"+barcode;
            }catch(err){
                alert("barcodeReceived:"+err.message);
            }
		}
        var barcodeDataListener = function(msg){
            try{
                var inf = String.fromCharCode.apply(null, new Uint8Array(msg));
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n barcodeDataListener:"+ inf;
            }catch(err){
                alert("barcodeDataListener:"+err.message);
            }
        }
		var memoryReceived = function(memory){
			try{
                alert("memoryReceived:"+memory);
				//alert(pcEpcData.byteLength);
				var dataView= new DataView(memory);
				var str = "";
				for(i = 0; i<memory.byteLength;i++){
					//alert (i);
					str += dataView.getUint8(i).toString(16).toUpperCase();
				}
				//alert(str);
				document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\nMEMODataHex:"+str;
			}catch(err){
                alert("memoryReceived:"+err.message);
			}
			
		}
		var memoryReceivedErr = function(msg){
            alert("memoryReceivedErr:"+msg);
		}
		var barcodeReaderPlugged = function(status){
			//alert(status);
			if(status == 'YES'){
				document.getElementById("deviceready").querySelector('.asr_bc_plugged').setAttribute('style', 'display:block;');
				asreader.barcodePowerOn(barcodesuccess,barcodefailure);
			}else{
				document.getElementById("deviceready").querySelector('.asr_bc_plugged').setAttribute('style', 'display:none;');
				document.getElementById("deviceready").querySelector('.asr_bc_poweron').setAttribute('style', 'display:none;');
			}
		}
		
		var rfidReaderPlugged = function(status){
			if(status == 'YES'){
				document.getElementById("deviceready").querySelector('.asr_rf_plugged').setAttribute('style', 'display:block;');
				asreader.rfidPowerOn(rfidsuccess,rfidfailure);
			}else{
				document.getElementById("deviceready").querySelector('.asr_rf_plugged').setAttribute('style', 'display:none;');
				document.getElementById("deviceready").querySelector('.asr_rf_poweron').setAttribute('style', 'display:none;');
			}
		}
		
		var rfidPcEpcStringReceived = function(pcEpcString){
			try{
			document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidPcEpcStringListener"+pcEpcString;
            }catch(err){
                alert("rfidPcEpcStringReceived:"+err.message);
            }
		}
		var rfidPcEpcDataReceived = function(pcEpcData){
			
			try{
				
				//alert(pcEpcData.byteLength);
//                var dataView= new DataView(pcEpcData);
//                var str = "";
//                for(i = 0; i<pcEpcData.byteLength;i++){
//                    //alert (i);
//                    str += "Ox"+dataView.getUint8(i).toString(16).toUpperCase();
//                }
				//alert(str);
                var dfg = Array.prototype.map.call(new Uint8Array(pcEpcData), x => ('00' + x.toString(16)).slice(-2)).join('');
				document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidPcEpcDataListener:"+dfg;
			}catch(err){
                alert("rfidPcEpcDataReceived:"+err.message);
			}
			
			//alert(String.fromCharCode.apply(null, new Uint16Array(pcEpcData)));
			//document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n"+pcEpcString;
		}

		var rfidEpcDataReceived = function(epcData){
			
			try{
                
                var dfg = Array.prototype.map.call(new Uint8Array(epcData), x => ('00' + x.toString(16)).slice(-2)).join('');
               // asreader.readTagMemoryNotifyTo(memoryReceived,memoryReceivedErr,0x00000000,dfg,0x01,0x00,8);
//                var dataView= new DataView(epcData);
//                var str = "";
//                for(i = 0; i<epcData.byteLength;i++){
//                    //alert (i);
//                    str += dataView.getUint8(i).toString(16).toUpperCase();
//                }
				
				//alert(pcEpcData.byteLength);
//                var dataView= new DataView(epcData);
//                var str = "";
//                for(i = 0; i<epcData.byteLength;i++){
//                    //alert (i);
//                    str += dataView.getUint8(i).toString(16).toUpperCase();
//                }
				//alert(str);

				document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidEpcDataListener:"+dfg;
			}catch(err){
                alert("rfidEpcDataReceived:"+err.message);
			}
			
			//alert(String.fromCharCode.apply(null, new Uint16Array(pcEpcData)));
			//document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n"+pcEpcString;
		}
		var rfidEpcDataTidReceived = function(epcAndTid){
			
			try{
				alert(epcAndTid);
			}catch(err){
                alert("rfidEpcDataTidReceived:"+err.message);
			}
			
			//alert(String.fromCharCode.apply(null, new Uint16Array(pcEpcData)));
			//document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n"+pcEpcString;
		}
		
		var rfidEpcStrTidReceived = function(epcAndTid){
			
			try{

                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidEpcStringWithTidListener: EPC:"+ epcAndTid["Epc"] +"TID:"+ epcAndTid["Tid"];
				
			}catch(err){
                alert("rfidEpcStrTidReceived:"+err.message);
			}
			
			//alert(String.fromCharCode.apply(null, new Uint16Array(pcEpcData)));
			//document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n"+pcEpcString;
		}
		var barcodePowerListener = function(power){
			
			//alert(String.fromCharCode.apply(null, new Uint16Array(pcEpcData)));
			document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setBarcodePowerListener:"+power;
			if(power =='ON'){
				document.getElementById("deviceready").querySelector('.asr_bc_poweron').setAttribute('style', 'display:block;');
			}else{
				document.getElementById("deviceready").querySelector('.asr_bc_poweron').setAttribute('style', 'display:none;');
			}
		}

		var rfidPowerListener = function(power){
			
			//alert(String.fromCharCode.apply(null, new Uint16Array(pcEpcData)));
			document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidPowerListener:"+power;
			if(power =='ON'){
				document.getElementById("deviceready").querySelector('.asr_rf_poweron').setAttribute('style', 'display:block;');
			}else{
				document.getElementById("deviceready").querySelector('.asr_rf_poweron').setAttribute('style', 'display:none;');
			}
		}
		
		var rfidPcEpcDataWithRssiReceived = function(dic){
            document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n"+ "setRfidPcEpcStringWithRssiListener: PcEpc:" + dic["PcEpc"]+" Rssi:" + dic["Rssi"];
			//alert("PcEpc:" + dic["PcEpc"]+" Rssi:" + dic["Rssi"]);
		}
		var configSuccess = function(status){
			alert(status);
		}
		var configFail = function(status){
            alert("configFail:"+status);
		}
		var readerReady = function(status){
			try{
				alert("readerReady:"+status);
//                asreader.configureRfid(configSuccess,configFail,"YES","YES","NO");
				asreader.setRfidStartedReadTagListener(startedReaderTagListener);
			}catch(err){
                alert("readerReady:"+err.message);
			}
		}
		var receiveStopCon = function(condition){
			alert(condition);
		}
		var conSetted = function(status){
			alert(status);
		}
		var errf = function(msg){
            alert("errf:"+msg);
		}
		var startedReaderTagWithRssiListener = function(status){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidStartedReadTagWithRssiListener:"+ status;
            }catch(err){
                alert("startedReaderTagWithRssiListener:"+err.message);
            }
		}
		var startedReaderTagListener = function(status){
			try{
				//var ti = new Date().getTime();
            document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidStartedReadTagListener:"+ status;
			}catch(err){
                alert("startedReaderTagListener:"+err.message);
			}
		}
        var setRfidStartedReadTagListener = function(status){
            try{
                //var ti = new Date().getTime();
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidStartedReadTagListener:"+ status;
            }catch(err){
                alert("setRfidStartedReadTagListener:"+err.message);
            }
        }
		var success = function(msg){
			try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
			}catch(err){
                alert("success:"+err.message);
			}
		}
		var error = function(msg){
			try{
				document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n ERR:"+ msg;
			}catch(err){
                alert("error:"+err.message);
			}
		}
        var listener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
            }catch(err){
                alert("listener:"+err.message);
            }
        }

        var errListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setErrListener:"+ msg;
            }catch(err){
                alert("errListener:"+err.message);
            }
        }
        var errDetailListener = function(msg){
            try{
                var inf = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setErrDetailListener:"+ inf;
            }catch(err){
                alert("errDetailListener:"+err.message);
            }
        }
        var startedReadListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setStartedReadListener:"+ msg;
            }catch(err){
                alert("startedReadListener:"+err.message);
            }
        }
        var stoppedReadListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setStoppedReadListener:"+ msg;
            }catch(err){
                alert("stoppedReadListener:"+err.message);
            }
        }
        var chargingControlListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setChargingControlListener:"+ msg;
            }catch(err){
                alert("chargingControlListener:"+err.message);
            }
        }
        var batteryListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setBatteryListener:"+ msg;
            }catch(err){
                alert("batteryListener:"+err.message);
            }
        }
        var rfidPcEpcSensorDataWithSensorDataListener = function(msg){
            try{
                var str = "";
                for(var item in msg){
                    str += item+"="+msg[item]+"\n";
                }
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidPcEpcSensorDataWithSensorDataListener:"+ str;
            }catch(err){
                alert("rfidPcEpcSensorDataWithSensorDataListener:"+err.message);
            }
        }
        var rfidReaderConnectedListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidReaderConnectedListener:"+ msg;
            }catch(err){
                alert("rfidReaderConnectedListener:"+err.message);
            }
        }
        var setbarcodeEncodeStringListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setBarcodeStringReceivedListener:"+ msg;
            }catch(err){
                alert("setbarcodeEncodeStringListener:"+err.message);
            }
        }


        var rfidStoppedReadTagsListener = function(msg){
            try{
                //var inf = JSON.stringify(msg);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidStoppedReadTagsListener:"+ msg;
            }catch(err){
                alert("rfidStoppedReadTagsListener:"+err.message);
            }
        }
//        var rfidReaderInfoReceivedListener = function(msg){
//            try{
//                var inf = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
//                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidReaderInfoReceivedListener:"+ inf;
//            }catch(err){
//                alert(err.message);
//            }
//        }

        var setBarcodeChargingControl = function(isOn) {
            
            // 成功時のコールバック関数
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("isOn:"+isOn);

            }
            
            // エラー時のコールバック関数
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setBarcodeChargingControl(success, error, isOn);
            
        }
        var setRfidChargingControl = function(isOn) {
            
            // 成功時のコールバック関数
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("isOn:"+isOn);
            };
            
            // エラー時のコールバック関数
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            
            asreader.setRfidChargingControl(success, error, isOn);

        }

        var barcodePowerOnAndConfigure =function(beepOn,viberationOn,illuminationOn){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("beepOn:"+beepOn+" viberationOn:"+viberationOn+" illuminationOn:"+illuminationOn);
            };

            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.barcodePowerOnAndConfigure(success, error, beepOn,viberationOn,illuminationOn);
        }
        var configureBarcode =function(beepOn,viberationOn,illuminationOn){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("beepOn:"+beepOn+" viberationOn:"+viberationOn+" illuminationOn:"+illuminationOn);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.configureBarcode(success, error, beepOn,viberationOn,illuminationOn);
        }
        var rfidSetReaderPower =function(on, connectedBeep){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("on:"+on+" connectedBeep:"+connectedBeep);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.rfidReaderPower(success, error, on, connectedBeep);
        }
        var setChannelAndNotifyTo =function(channel,offset){
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("channel:"+channel+" offset:"+offset);
            };

            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.setChannelAndNotifyTo(listener,error,channel,offset);
        }
        var rfidSetReaderPowerOnWithBeep =function(beepOn,viberationOn,illuminationOn){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("beepOn:"+beepOn+" viberationOn:"+viberationOn+" illuminationOn:"+illuminationOn);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.rfidReaderPowerOnWithBeep(success, error, beepOn,viberationOn,illuminationOn);
        }
        var configureRfid =function(beepOn,viberationOn,illuminationOn){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("beepOn:"+beepOn+" viberationOn:"+viberationOn+" illuminationOn:"+illuminationOn);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.configureRfid(success, error, beepOn,viberationOn,illuminationOn);
        }
        var lockTagAndNotifyTo =function(accessPassword,epc,targetMemory, action){
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("accessPassword:"+accessPassword+" epc:"+epc+" targetMemory:"+targetMemory+" action:"+action);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.lockTagAndNotifyTo(listener,error,accessPassword,epc,targetMemory, action);
        }
        
        var rfidStartReadTagsRFM =function(codeType, mtnu, mtime, repeatCycle){
            asreader.setRfidPcEpcSensorDataWithSensorDataListener(rfidPcEpcSensorDataWithSensorDataListener);
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("codeType:"+codeType+" mtnu:"+mtnu+" mtime:"+mtime+" repeatCycle:"+repeatCycle);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.startReadTagsAndRFM(success, error, codeType, mtnu, mtime, repeatCycle);
        }
        


        var setFhLbtAndNotifyTo =function(readTime,idleTime,carrierSenseTime,rfLevel,frequencyHopping,listenBeforeTalk,continuousWave){
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("readTime:"+readTime+" idleTime:"+idleTime+" carrierSenseTime:"+carrierSenseTime+" rfLevel:"+rfLevel+" frequencyHopping:"+frequencyHopping+" listenBeforeTalk:"+listenBeforeTalk+" continuousWave:"+continuousWave);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
        asreader.setFhLbtAndNotifyTo(listener,error,readTime,idleTime,carrierSenseTime,rfLevel,frequencyHopping,listenBeforeTalk,continuousWave);
        }
        var readTagMemoryNotifyTos = function(accessPassword,epc,memoryBank,startAddress,dataLength){

            var listener = function(msg) {
                var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ dfg;
                alert("accessPassword:"+accessPassword+" epc:"+epc+" memoryBank:"+memoryBank+" startAddress:"+startAddress+" dataLength:"+dataLength);
            };

            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+errmsg);
            }
        asreader.readTagMemoryNotifyTo(listener,error,accessPassword,epc,memoryBank,startAddress,dataLength);
        }
        var startReadTagsWithParams = function(mtnu,mtime,repeatCycle){

            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("mtnu:"+mtnu+" mtime:"+mtime+" repeatCycle:"+repeatCycle);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+errmsg);
            }
            asreader.startReadTagsWithParams(success, error, mtnu, mtime, repeatCycle);
        }
        var startReadTagsAndRssiWithParams = function(mtnu,mtime,repeatCycle){
            
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("mtnu:"+mtnu+" mtime:"+mtime+" repeatCycle:"+repeatCycle);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+errmsg);
            }
            asreader.startReadTagsAndRssiWithParams(success, error, mtnu, mtime, repeatCycle);
        }
        var setStopConditionAndNotifyTo = function(mtnu,mtime,repeatCycle){
            
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("mtnu:"+mtnu+" mtime:"+mtime+" repeatCycle:"+repeatCycle);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+errmsg);
            }
            asreader.setStopConditionAndNotifyTo(listener, error, mtnu, mtime, repeatCycle);
        }
        var setSelectParamAndNotifyTo = function(target,action,memoryBank,pointer,length,truncate,mask){

            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("target:"+target+" action:"+action+" memoryBank:"+memoryBank+" pointer:"+pointer+" length:"+length+" truncate:"+truncate+" mask:"+mask);
            };

            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+errmsg);
            }
            asreader.setSelectParamAndNotifyTo(listener,error,target,action,memoryBank,pointer,length,truncate,mask);
        }
        var startReadTagsAndTidWithParams =function(mtnu, mtime, repeatCycle){
            //asreader.setRfidEpcDataWithTidListener(setRfidEpcDataWithTidListener);
            asreader.setRfidEpcStringWithTidListener(rfidEpcStrTidReceived);
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("mtnu:"+mtnu+" mtime:"+mtime+" repeatCycle:"+repeatCycle);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.startReadTagsAndTidWithParams(success, error, mtnu, mtime, repeatCycle);
        }
        var setWriteToTagMemoryToAsciiAndNotifyTo =function(epc, dataToWrite){

            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("epc:"+epc+" dataToWrite:"+dataToWrite);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setWriteToTagMemoryToAsciiAndNotifyTo(listener, error, epc, dataToWrite);
        }
        var setWriteToTagMemoryToHexAndNotifyTo = function(epc, dataToWrite){
            
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("epc:"+epc+" dataToWrite:"+dataToWrite);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setWriteToTagMemoryToHexAndNotifyTo(listener, error, epc, dataToWrite);
        }
        var setFreqHoppingTableAndNotifyTo = function(tableSize,channels){
            
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("tableSize:"+tableSize+" channels:"+channels);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setFreqHoppingTableAndNotifyTo(listener,error,tableSize,channels);
        }
        var killTagAndNotifyTo = function(accessPassword,epc){
            
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("accessPassword:"+accessPassword+" epc:"+epc);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.killTagAndNotifyTo(listener,error,accessPassword,epc);
        }
        var setFrequencyHoppingModeAndNotifyTo = function(mode){
            
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("mode:"+mode);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setFrequencyHoppingModeAndNotifyTo(listener,error, mode);
        }
        var setRSSIThreshold = function(threshold){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("threshold:"+threshold);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setRSSIThreshold(success,error,threshold);
        }

        var setOutputPowerLevelAndNotifyTo = function(power){

            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("power:"+power);
            };

            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("error:"+ errmsg);
            }
            asreader.setOutputPowerLevelAndNotifyTo(listener,error,power);
        }
        var setAnticollisionMode = function(mode){
            
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("mode:"+mode);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.setAnticollisionMode(success,error,mode);
        }
        var notifyReaderInfoTo = function(infoType){
            
            var listener = function(msg) {
                var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                var info = '0x'+dfg;
                var trimedStr = info.trim();
                var rawStr = trimedStr.substr(0, 2).toLowerCase() === "0x" ? trimedStr.substr(2) : trimedStr;
                var len = rawStr.length;
                var curCharCode;
                var resultStr = [];
                for (var i = 0; i < len; i = i + 2) {
                    curCharCode = parseInt(rawStr.substr(i, 2), 16);
                    resultStr.push(String.fromCharCode(curCharCode));
                }
                var vals = resultStr.join("");
                
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ dfg+"\n string:"+ vals;
                alert("infoType:"+infoType);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.notifyReaderInfoTo(listener, error, infoType);
        }
        var setSessionAndNotifyTo = function(session){
            var listener = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("session:"+session);
            };
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.setSessionAndNotifyTo(listener,error,session);
        }
        var rfidSetTriggerModeDefault = function(isDefault){
            
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                alert("isDefault:"+isDefault);
            };
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.setRfidTriggerModeDefault(success, error, isDefault);
        }
        var rfidAnticolParamWithStartWithMaxWithMinListener = function(msg){
            try{
                var str = "";
                for(var item in msg){
                    str += item+"="+msg[item]+"\n";
                }
                //var inf = JSON.stringify(msg);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidAnticolParamWithStartWithMaxWithMinListener:"+ str;
            }catch(err){
                alert("rfidAnticolParamWithStartWithMaxWithMinListener:"+err.message);
            }
        }

        var setRfidChargingControlListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidChargingControlListener:"+ msg;
            }catch(err){
                alert("setRfidChargingControlListener:"+err.message);
            }
        }
        var setRfidPushedTriggerButtonListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidPushedTriggerButtonListener:"+ msg;
            }catch(err){
                alert("setRfidPushedTriggerButtonListener:"+err.message);
            }
        }
        var setRfidReleasedTriggerButtonListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidReleasedTriggerButtonListener:"+ msg;
            }catch(err){
                alert("setRfidReleasedTriggerButtonListener:"+err.message);
            }
        }
        var setRfidEpcStringListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidEpcStringListener:"+ msg;
            }catch(err){
                alert("setRfidEpcStringListener:"+err.message);
            }
        }
//        var setRfidPcEpcDataWithRssiListener = function(msg){
//            try{
//                var str = "";
//                for(var item in msg){
//                    str += item+"="+msg[item]+"\n";
//                }
//                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidPcEpcDataWithRssiListener:"+ str;
//            }catch(err){
//                alert(err.message);
//            }
//        }
//        var setRfidEpcDataWithRssiListener = function(msg){
//            try{
//                var str = "";
//                for(var item in msg){
//                    str += item+"="+msg[item]+"\n";
//                }
//                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidEpcDataWithRssiListener:"+ str;
//            }catch(err){
//                alert(err.message);
//            }
//        }
        var setRfidEpcStringWithRssiListener = function(msg){
            try{
                var str = "";
                for(var item in msg){
                    str += item+"="+msg[item]+"\n";
                }
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidEpcStringWithRssiListener:"+ str;
            }catch(err){
                alert("setRfidEpcStringWithRssiListener:"+err.message);
            }
        }
//        var setRfidEpcDataWithTidListener = function(msg){
//            try{
//                var str = "";
//                for(var item in msg){
//                    str += item+"="+msg[item]+"\n";
//                }
//                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidEpcDataWithTidListener:"+ str;
//            }catch(err){
//                alert(err.message);
//            }
//        }
        var setRfidAckReceivedListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidAckReceivedListener:"+ msg;
            }catch(err){
                alert("setRfidAckReceivedListener:"+err.message);
            }
        }
        var setReaderReadyListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setReaderReadyListener:"+ msg;
            }catch(err){
                alert("setReaderReadyListener:"+err.message);
            }
        }
        var setRfidAnticollisionModeListener = function(msg){
            try{
//                var str = "";
//                for(var item in msg){
//                    str += item+"="+msg[item]+"\n";
//                }
                //var inf = JSON.stringify(msg);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidAnticollisionModeListener:"+ msg;
            }catch(err){
                alert("setRfidAnticollisionModeListener:"+err.message);
            }
        }
        var setRfidOutputPowerLevelWithMaxPowerWithMainPowerListener = function(msg){
            try{
                var str = "";
                for(var item in msg){
                    str += item+"="+msg[item]+"\n";
                }
                //var inf = JSON.stringify(msg);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidOutputPowerLevelWithMaxPowerWithMainPowerListener:"+ str;
            }catch(err){
                alert("setRfidOutputPowerLevelWithMaxPowerWithMainPowerListener:"+err.message);
            }
        }
        var setRfidAnticolParamListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidAnticolParamListener:"+ msg;
            }catch(err){
                alert("setRfidAnticolParamListener:"+err.message);
            }
        }
        var setRfidAnticollisionModeAndOptionsListener = function(msg){
            try{
                //var inf = JSON.stringify(msg);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidAnticollisionModeAndOptionsListener:"+ msg;
                //return false;
            }catch(err){
                alert("setRfidAnticollisionModeAndOptionsListener:"+err.message);
            }
        }
        var arraybuffernotifyOutputPowerLevelTo = function(msg){
            try{
                var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                var power = (parseInt(dfg.substr(0,2),16) << 8) | parseInt(dfg.substr(2,2),16);
                var powerMin = (parseInt(dfg.substr(4,2),16) << 8) | parseInt(dfg.substr(6,2),16);
                var powerMax = (parseInt(dfg.substr(8,2),16) << 8) | parseInt(dfg.substr(10,2),16);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ dfg +"\n power:"+ power+"\n powerMin:"+ powerMin+"\n powerMax:"+ powerMax;
            }catch(err){
                alert("arraybuffernotifyOutputPowerLevelTo:"+err.message);
            }
        }
        var arraybuffernotifyStopConditionTo = function(msg){
            try{
                var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                var count = parseInt(dfg.substr(0,2),16);
                var time = parseInt(dfg.substr(2,2),16);
                var repeatcycle = parseInt(dfg.substr(4,4),16);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ dfg +"\n count:"+ count+"\n time:"+ time+"\n repeatcycle:"+ repeatcycle;
            }catch(err){
                alert("arraybuffernotifyStopConditionTo:"+err.message);
            }
        }
        var arraybuffernotifyFreqHoppingTableTo = function(msg){
            try{
                var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                var nLen = (parseInt(dfg.substr(0,2))*2+2);
                var arr=''+dfg+''.split("");
                var arrs=[];
                for(var i = 1;i<nLen;i++){
                    if(i%2>0){
                        var js=arr[i];
                        var os=arr[i+1];
                    }
                    arrs.push(''+js+''+''+os+'');
                }
                var array=[];
                for (var i = 0; i < arrs.length; i++) {
                    if (array.indexOf(arrs[i]) === -1) {
                        array.push(arrs[i]);
                    }
                }
                var str = array.join();
                
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ dfg+"\n str:"+ str;
            }catch(err){
                alert("arraybuffernotifyFreqHoppingTableTo:"+err.message);
            }
        }
        var arraybufferinfo = function(msg){
            
            try{
                var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                
                if(dfg.length<11){
                    return false;
                }else{
                    if(parseInt(dfg.substr(16,2),16)==0){
                        var ison = 0;
                    }else{
                        var ison = 1;
                    }
                    var readTime = (parseInt(dfg.substr(0,2),16) << 8) | parseInt(dfg.substr(2,2),16);
                    var idleTime = (parseInt(dfg.substr(4,2),16) << 8) | parseInt(dfg.substr(6,2),16);
                    var cst = (parseInt(dfg.substr(8,2),16) << 8) | parseInt(dfg.substr(10,2),16);
                    var rfl = (parseInt(dfg.substr(12,2),16) << 8) | parseInt(dfg.substr(14,2),16);
                    var lbt = parseInt(dfg.substr(18,2),16);
                    var cw = parseInt(dfg.substr(20,2),16);
                }
                
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener: \n ReadTime:" + readTime + "\n IdleTime:" + idleTime + "\n CarrierSenseTime:" + cst + "\n RFLevel:" + rfl + "\n FrequencyHopping:" + ison + "\n ListenBeforeTalk:" + lbt + "\n ContinuousWave:" + cw;
                
            }catch(err){
                alert("arraybufferinfo:"+err.message);
            }
        }
        var objectinfo = function(msg){
            try{
                var str = "";
                for(var item in msg){
                    str += item+"="+msg[item]+"\n";
                }
                //var inf = JSON.stringify(msg);
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener: \n"+ str;
            }catch(err){
                alert("objectinfo:"+err.message);
            }
        }
        var twovaluesinfo = function(msg){
            try{
                var typeofs = typeof(msg);
                if(typeofs=="string"){
                    document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ msg;
                }else{
                    var dfg = Array.prototype.map.call(new Uint8Array(msg), x => ('00' + x.toString(16)).slice(-2)).join('');
                    document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n listener:"+ dfg;
                }
               
            }catch(err){
                alert("twovaluesinfo:"+err.message);
            }
        }
		//asreader.powerOn("ON", success, failure);
		asreader.setReaderReadyListener(readerReady);
		asreader.setBarcodePluggedListener(barcodeReaderPlugged);
		asreader.setRfidPluggedListener(rfidReaderPlugged);
		asreader.setBarcodeStringListener(barcodeReceived);
		asreader.setRfidPcEpcStringListener(rfidPcEpcStringReceived);
        asreader.setBatteryListener(batteryListener);
		asreader.setRfidPcEpcDataListener(rfidPcEpcDataReceived);
		asreader.setRfidEpcDataListener(rfidEpcDataReceived);
        asreader.setBarcodeDataListener(barcodeDataListener);
        asreader.setBarcodeStringReceivedListener(setbarcodeEncodeStringListener);
        asreader.setStartedReadListener(startedReadListener);
        asreader.setStoppedReadListener(stoppedReadListener);
		asreader.setRfidPcEpcStringWithRssiListener(rfidPcEpcDataWithRssiReceived);
        asreader.setChargingControlListener(chargingControlListener);
		asreader.setBarcodePowerListener(barcodePowerListener);
		asreader.setRfidPowerListener(rfidPowerListener);
		asreader.setRfidStartedReadTagWithRssiListener(startedReaderTagWithRssiListener);
        asreader.setErrListener(errListener);
        asreader.setErrDetailListener(errDetailListener);
        
        asreader.setRfidReaderConnectedListener(rfidReaderConnectedListener);
        asreader.setRfidChargingControlListener(setRfidChargingControlListener);
        asreader.setRfidStoppedReadTagsListener(rfidStoppedReadTagsListener);
        //asreader.setRfidReaderInfoReceivedListener(rfidReaderInfoReceivedListener);
        asreader.setRfidEpcStringListener(setRfidEpcStringListener);
        //asreader.setRfidPcEpcDataWithRssiListener(setRfidPcEpcDataWithRssiListener);
        //asreader.setRfidEpcDataWithRssiListener(setRfidEpcDataWithRssiListener);
        asreader.setRfidEpcStringWithRssiListener(setRfidEpcStringWithRssiListener);
        asreader.setRfidPushedTriggerButtonListener(setRfidPushedTriggerButtonListener);
        asreader.setRfidReleasedTriggerButtonListener(setRfidReleasedTriggerButtonListener);
        
        asreader.setRfidAnticolParamListener(setRfidAnticolParamListener);
        asreader.setRfidAckReceivedListener(setRfidAckReceivedListener);
    asreader.setRfidOutputPowerLevelWithMaxPowerWithMainPowerListener(setRfidOutputPowerLevelWithMaxPowerWithMainPowerListener);
    asreader.setRfidAnticolParamWithStartWithMaxWithMinListener(rfidAnticolParamWithStartWithMaxWithMinListener);
        
		document.getElementById("barcodePowerOn").addEventListener('click',function(){asreader.barcodePowerOn(success,error);});
		document.getElementById("barcodePowerOff").addEventListener('click',function(){asreader.barcodePowerOff(success,error);});
		document.getElementById("readBarcode").addEventListener('click',function(){asreader.readBarcode(success,error);});
        document.getElementById("readBarcodeContinuously").addEventListener('click',function(){asreader.readBarcodeContinuously(success,error);});
		document.getElementById("stopReadBarcode").addEventListener('click',function(){
            asreader.setStoppedReadListener(stoppedReadListener);
            asreader.stopReadBarcode(success,error);});
        document.getElementById("startReadTagsAndRssi").addEventListener('click',function(){
            asreader.setRfidStartedReadTagListener(setRfidStartedReadTagListener);
            asreader.startReadTagsAndRssi(success,error);});
		document.getElementById("setEncodingJIS").addEventListener('click',function(){asreader.setBarcodeEncodingFormat(success,error,'ShiftJIS');});
		document.getElementById("setEncodingUTF8").addEventListener('click',function(){asreader.setBarcodeEncodingFormat(success,error,'UTF8');});
		document.getElementById("setEncodingUTF80").addEventListener('click',function(){asreader.setBarcodeEncodingFormat(success,error,'UTF80');});


		//
        document.getElementById("chargingControlBarcodeOn").addEventListener('click',function(){
             setBarcodeChargingControl(true);
          })
        document.getElementById("chargingControlBarcodeOff").addEventListener('click',function(){
             setBarcodeChargingControl(false);
          })
        document.getElementById("chargingControlRfidOn").addEventListener('click',function(){
             setRfidChargingControl(true);
         })
        document.getElementById("chargingControlRfidOff").addEventListener('click',function(){
             setRfidChargingControl(false);
         })
        //
     document.getElementById("barcodePowerOnAndConfigure").addEventListener('click',function(){
          asreader.setReaderReadyListener(setReaderReadyListener);
          var beepOn = document.getElementById("barcodePowerOnAndConfigurebeepOn").checked;
          var viberationOn = document.getElementById("barcodePowerOnAndConfigureviberationOn").checked;
          var illuminationOn = document.getElementById("barcodePowerOnAndConfigureilluminationOn").checked;
          //if(beepOn == true){beepOn = "YES";}else{beepOn = "NO";}
          //if(viberationOn == true){viberationOn = "YES";}else{viberationOn = "NO";}
          //if(illuminationOn == true){illuminationOn = "YES";}else{illuminationOn = "NO";}
          barcodePowerOnAndConfigure(beepOn,viberationOn,illuminationOn);
        });
        document.getElementById("isBarcodePlugged").addEventListener('click',function(){asreader.isBarcodePlugged(success,error);});
        document.getElementById("getSDKVersion").addEventListener('click',function(){asreader.getSDKVersion(success,error);});
        document.getElementById("configureBarcode").addEventListener('click',function(){
          asreader.setReaderReadyListener(setReaderReadyListener);
          var beepOn = document.getElementById("configureBarcodebeepOn").checked;
          var viberationOn = document.getElementById("configureBarcodeviberationOn").checked;
          var illuminationOn = document.getElementById("configureBarcodeilluminationOn").checked;
          //if(beepOn == true){beepOn = "YES";}else{beepOn = "NO";}
          //if(viberationOn == true){viberationOn = "YES";}else{viberationOn = "NO";}
          //if(illuminationOn == true){illuminationOn = "YES";}else{illuminationOn = "NO";}
          configureBarcode(beepOn,viberationOn,illuminationOn);
        });
        document.getElementById("rfidSetReaderPower").addEventListener('click',function(){
          asreader.setReaderReadyListener(setReaderReadyListener);
          var on = document.getElementById("rfidSetReaderPoweron").checked;
          var connectedBeep = document.getElementById("rfidSetReaderPowerconnectedBeep").checked;
             
          rfidSetReaderPower(on,connectedBeep);
         });
        document.getElementById("setChannelAndNotifyTo").addEventListener('click',function(){
          var channel = document.getElementById("setChannelAndNotifyTochannel").value;
          var offset = document.getElementById("setChannelAndNotifyTooffset").value;
          
          setChannelAndNotifyTo(channel,offset);
        });
        document.getElementById("rfidSetReaderPowerOnWithBeep").addEventListener('click',function(){
          asreader.setRfidReaderConnectedListener(rfidReaderConnectedListener);
          var beepOn = document.getElementById("rfidSetReaderPowerOnWithBeepbeepOn").checked;
          var viberationOn = document.getElementById("rfidSetReaderPowerOnWithBeepvibrationOn").checked;
          var illuminationOn = document.getElementById("rfidSetReaderPowerOnWithBeepilluminationOn").checked;
          
          rfidSetReaderPowerOnWithBeep(beepOn,viberationOn,illuminationOn);
        });
        document.getElementById("configureRfid").addEventListener('click',function(){
          asreader.setRfidReaderConnectedListener(rfidReaderConnectedListener);
          var beepOn = document.getElementById("configureRfidbeepOn").checked;
          var viberationOn = document.getElementById("configureRfidvibrationOn").checked;
          var illuminationOn = document.getElementById("configureRfidilluminationOn").checked;
         
          configureRfid(beepOn,viberationOn,illuminationOn);
         });
        document.getElementById("lockTagAndNotifyTo").addEventListener('click',function(){
          var accessPassword = document.getElementById("lockTagAndNotifyToaccessPassword").value;
          var epc = document.getElementById("lockTagAndNotifyToepc").value;
          var targetMemory = document.getElementById("lockTagAndNotifyTotargetMemory").value;
          var action = document.getElementById("lockTagAndNotifyToaction").value;
         
          lockTagAndNotifyTo(accessPassword,epc,targetMemory, action);
        });
        document.getElementById("setAnticollisionModeAndCount").addEventListener('click',function(){
          asreader.setRfidAnticollisionModeAndCountListener(setRfidAnticollisionModeAndCountListener);
          var mode = document.getElementById("setAnticollisionModeAndCountmode").value;
          var qStart = document.getElementById("setAnticollisionModeAndCountqStart").value;
          var qMax = document.getElementById("setAnticollisionModeAndCountqMax").value;
          var qMin = document.getElementById("setAnticollisionModeAndCountqMin").value;
          var count = document.getElementById("setAnticollisionModeAndCountcount").value;
        
          setAnticollisionModeAndCount(mode,qStart,qMax,qMin,count);
        });
        var setAnticollisionModeAndCount =function(mode,qStart,qMax,qMin,count){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("mode:"+mode+" qStart:"+qStart+" qMax:"+qMax+" qMin:"+qMin+" count:"+count);
            }
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.setAnticollisionModeAndCount(success,error,mode,qStart,qMax,qMin,count);
        }
        document.getElementById("rfidStartReadTagsRFM").addEventListener('click',function(){
          var codeType = document.getElementById("rfidStartReadTagsRFMcodeType").value;
          var mtnu = document.getElementById("rfidStartReadTagsRFMmtnu").value;
          var mtime = document.getElementById("rfidStartReadTagsRFMmtime").value;
          var repeatCycle = document.getElementById("rfidStartReadTagsRFMrepeatCycle").value;
          
          rfidStartReadTagsRFM(codeType,mtnu,mtime,repeatCycle);
        });
        document.getElementById("setAnticollisionModeAndOptions").addEventListener('click',function(){
          asreader.setRfidAnticollisionModeAndOptionsListener(setRfidAnticollisionModeAndOptionsListener);
          var mode = document.getElementById("setAnticollisionModeAndOptionsmode").value;
          var qStart = document.getElementById("setAnticollisionModeAndOptionsqStart").value;
          var qMax = document.getElementById("setAnticollisionModeAndOptionsqMax").value;
          var qMin = document.getElementById("setAnticollisionModeAndOptionsqMin").value;
         
          setAnticollisionModeAndOptions(mode,qStart,qMax,qMin);
        });
        var setAnticollisionModeAndOptions =function(mode, qStart, qMax, qMin){
            var success = function(msg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n success:"+ msg;
                alert("mode:"+mode+" qStart:"+qStart+" qMax:"+qMax+" qMin:"+qMin);
            }
            
            var error = function(errmsg) {
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n error:"+ errmsg;
                alert("設定に失敗しました");
            }
            asreader.setAnticollisionModeAndOptions(success,error,mode,qStart,qMax,qMin);
        }
        var setRfidAnticollisionModeAndCountListener = function(msg){
            try{
                document.getElementById("datareceived").value = document.getElementById("datareceived").value+"\n setRfidAnticollisionModeAndCountListener:"+ msg;
            }catch(err){
                alert("setRfidAnticollisionModeAndCountListener:"+err.message);
            }
        }
        document.getElementById("setFhLbtAndNotifyTo").addEventListener('click',function(){
          var readTime = document.getElementById("setFhLbtAndNotifyToreadTime").value;
          var idleTime = document.getElementById("setFhLbtAndNotifyToidleTime").value;
          var carrierSenseTime = document.getElementById("setFhLbtAndNotifyTocarrierSenseTime").value;
          var rfLevel = document.getElementById("setFhLbtAndNotifyTorfLevel").value;
          var frequencyHopping = document.getElementById("setFhLbtAndNotifyTofrequencyHopping").value;
          var listenBeforeTalk = document.getElementById("setFhLbtAndNotifyTolistenBeforeTalk").value;
          var continuousWave = document.getElementById("setFhLbtAndNotifyTocontinuousWave").value;
      setFhLbtAndNotifyTo(readTime,idleTime,carrierSenseTime,rfLevel,frequencyHopping,listenBeforeTalk,continuousWave);
        });
        document.getElementById("readTagMemoryNotifyTo").addEventListener('click',function(){
          var accessPassword = document.getElementById("readTagMemoryNotifyToaccessPassword").value;
          var epc = document.getElementById("readTagMemoryNotifyToepc").value;
          var memoryBank = document.getElementById("readTagMemoryNotifyTomemoryBank").value;
          var startAddress = document.getElementById("readTagMemoryNotifyTostartAddress").value;
          var dataLength = document.getElementById("readTagMemoryNotifyTodataLength").value;
          readTagMemoryNotifyTos(accessPassword,epc,memoryBank,startAddress,dataLength);
        });
        document.getElementById("startReadTagsWithParams").addEventListener('click',function(){
            var mtnu = document.getElementById("startReadTagsWithParamsmtnu").value;
            var mtime = document.getElementById("startReadTagsWithParamsmtime").value;
            var repeatCycle = document.getElementById("startReadTagsWithParamsrepeatCycle").value;
            startReadTagsWithParams(mtnu,mtime,repeatCycle);
        });
        document.getElementById("startReadTagsAndRssiWithParams").addEventListener('click',function(){
            asreader.setRfidStartedReadTagListener(setRfidStartedReadTagListener);
            var mtnu = document.getElementById("startReadTagsAndRssiWithParamsmtnu").value;
            var mtime = document.getElementById("startReadTagsAndRssiWithParamsmtime").value;
            var repeatCycle = document.getElementById("startReadTagsAndRssiWithParamsrepeatCycle").value;
            startReadTagsAndRssiWithParams(mtnu,mtime,repeatCycle);
            });
        document.getElementById("setStopConditionAndNotifyTo").addEventListener('click',function(){
           var mtnu = document.getElementById("setStopConditionAndNotifyTomtnu").value;
           var mtime = document.getElementById("setStopConditionAndNotifyTomtime").value;
           var repeatCycle = document.getElementById("setStopConditionAndNotifyTorepeatCycle").value;
           setStopConditionAndNotifyTo(mtnu,mtime,repeatCycle);
           });
        document.getElementById("setSelectParamAndNotifyTo").addEventListener('click',function(){
            var target = document.getElementById("setSelectParamAndNotifyToTarget").value;
            var action = document.getElementById("setSelectParamAndNotifyToAction").value;
            var memoryBank = document.getElementById("setSelectParamAndNotifyToMemoryBank").value;
            var pointer = document.getElementById("setSelectParamAndNotifyToPointer").value;
            var length = document.getElementById("setSelectParamAndNotifyToLength").value;
            var truncate = document.getElementById("setSelectParamAndNotifyToTruncate").value;
            var mask = document.getElementById("setSelectParamAndNotifyToMask").value;
            setSelectParamAndNotifyTo(target,action,memoryBank,pointer,length,truncate,mask);
            });
        document.getElementById("startReadTagsAndTidWithParams").addEventListener('click',function(){
            var mtnu = document.getElementById("startReadTagsAndTidWithParamsmtnu").value;
            var mtime = document.getElementById("startReadTagsAndTidWithParamsmtime").value;
            var repeatCycle = document.getElementById("startReadTagsAndTidWithParamsrepeatCycle").value;
            startReadTagsAndTidWithParams(mtnu, mtime, repeatCycle);});
    document.getElementById("setWriteToTagMemoryToAsciiAndNotifyTo").addEventListener('click',function(){
        var epc = document.getElementById("setWriteToTagMemoryToAsciiAndNotifyToepc").value;
        var dataToWrite = document.getElementById("setWriteToTagMemoryToAsciiAndNotifyTodataToWrite").value;
        setWriteToTagMemoryToAsciiAndNotifyTo(epc, dataToWrite);});
    document.getElementById("setWriteToTagMemoryToHexAndNotifyTo").addEventListener('click',function(){
        var epc = document.getElementById("setWriteToTagMemoryToHexAndNotifyToepc").value;
        var dataToWrite = document.getElementById("setWriteToTagMemoryToHexAndNotifyTodataToWrite").value;
        setWriteToTagMemoryToHexAndNotifyTo(epc, dataToWrite);});
        document.getElementById("setFreqHoppingTableAndNotifyTo").addEventListener('click',function(){
            var tableSize = document.getElementById("setFreqHoppingTableAndNotifyTotableSize").value;
            var channels = document.getElementById("setFreqHoppingTableAndNotifyTochannels").value;
            setFreqHoppingTableAndNotifyTo(tableSize,channels);});
        document.getElementById("killTagAndNotifyTo").addEventListener('click',function(){
            var accessPassword = document.getElementById("killTagAndNotifyToaccessPassword").value;
            var epc = document.getElementById("killTagAndNotifyToepc").value;
            killTagAndNotifyTo(accessPassword,epc);});
        document.getElementById("setFrequencyHoppingModeAndNotifyTo").addEventListener('click',function(){
            var mode = document.getElementById("setFrequencyHoppingModeAndNotifyTomode").value;
            setFrequencyHoppingModeAndNotifyTo(mode);});
        document.getElementById("setRSSIThreshold").addEventListener('click',function(){
            var threshold = document.getElementById("setRSSIThresholdthreshold").value;
            setRSSIThreshold(threshold);});

        document.getElementById("setAnticollisionMode").addEventListener('click',function(){
            asreader.setRfidAnticollisionModeListener(setRfidAnticollisionModeListener);
            var mode = document.getElementById("setAnticollisionModemode").value;
           //  if(mode == 0 || mode == 1 || mode == 2 || mode == 3){
                setAnticollisionMode(mode);
           // }else{
                // alert("Range from 0 to 3, please enter a right value");
                // document.getElementById("setAnticollisionModemode").value='';
           // }
                                                                         
              });
        document.getElementById("notifyReaderInfoTo").addEventListener('click',function(){
            var infoType = document.getElementById("notifyReaderInfoToinfoType").value;
            infoType = parseInt(infoType);
            notifyReaderInfoTo(infoType);});
        
        document.getElementById("setSessionAndNotifyTo").addEventListener('click',function(){
            var session = document.getElementById("setSessionAndNotifyTosession").value;
            setSessionAndNotifyTo(session);});
        document.getElementById("setOutputPowerLevelAndNotifyTo").addEventListener('click',function(){
            var power = document.getElementById("setOutputPowerLevelAndNotifyToPower").value;
            setOutputPowerLevelAndNotifyTo(power);});
        document.getElementById("rfidSetTriggerModeDefault").addEventListener('click',function(){
            
            var isDefault = document.getElementById("rfidSetTriggerModeDefaultisDefault").checked;
            if(isDefault == true){
                isDefault = "NO";
              }else{
                isDefault = "YES";
              }
            rfidSetTriggerModeDefault(isDefault);});
        document.getElementById("isRfidPlugged").addEventListener('click',function(){asreader.isRfidPlugged(success,error);});
        document.getElementById("notifyRSSIThresholdTo").addEventListener('click',function(){asreader.notifyRSSIThresholdTo(listener, error);});
        document.getElementById("notifyChannelTo").addEventListener('click',function(){asreader.notifyChannelTo(objectinfo,error);});
        document.getElementById("notifySelectParamTo").addEventListener('click',function(){asreader.notifySelectParamTo(arraybufferinfo,error);});
        document.getElementById("notifySessionTo").addEventListener('click',function(){asreader.notifySessionTo(listener,error);});
        document.getElementById("notifyFhLbtParamTo").addEventListener('click',function(){asreader.notifyFhLbtParamTo(arraybufferinfo,error);});
        document.getElementById("notifyReaderSettingInfoTo").addEventListener('click',function(){asreader.notifyReaderSettingInfoTo(objectinfo,error);});
        document.getElementById("notifyFreqHoppingTableTo").addEventListener('click',function(){asreader.notifyFreqHoppingTableTo(arraybuffernotifyFreqHoppingTableTo,error);});
        document.getElementById("notifyRssiTo").addEventListener('click',function(){asreader.notifyRssiTo(listener,error);});
     document.getElementById("setOptimumFrequencyHoppingTableAndNotifyTo").addEventListener('click',function(){asreader.setOptimumFrequencyHoppingTableAndNotifyTo(listener,error);});

        document.getElementById("rfidPowerOff").addEventListener('click',function(){asreader.rfidPowerOff(success,error);});
        document.getElementById("notifyRegionTo").addEventListener('click',function(){asreader.notifyRegionTo(listener,error);});
		document.getElementById("rfidPowerOn").addEventListener('click',function(){asreader.rfidPowerOn(success,error);});
		document.getElementById("startReadTags").addEventListener('click',function(){asreader.startReadTags(success,error);});
        document.getElementById("notifyOutputPowerLevelTo").addEventListener('click',function(){asreader.notifyOutputPowerLevelTo(arraybuffernotifyOutputPowerLevelTo,error);});
		
		document.getElementById("stopReadTags").addEventListener('click',function(){asreader.stopReadTags(success,error);});
        document.getElementById("getAnticollision").addEventListener('click',function(){
            asreader.setRfidAnticolParamListener(setRfidAnticolParamListener);
        asreader.setRfidAnticolParamWithStartWithMaxWithMinListener(rfidAnticolParamWithStartWithMaxWithMinListener);
            asreader.getAnticollision(success,error);});
        document.getElementById("updateRfidRegistryAndNotifyTo").addEventListener('click',function(){asreader.updateRfidRegistryAndNotifyTo(listener,error);});
		document.getElementById("notifyGetFrequencyHoppingModeLevelTo").addEventListener('click',function(){asreader.notifyGetFrequencyHoppingModeLevelTo(listener,error);});

		document.getElementById("notifyStopConditionTo").addEventListener('click',function(){
			
			try{
				//alert(receiveStopCon);
				asreader.notifyStopConditionTo (arraybuffernotifyStopConditionTo,errf);
			}catch(err){
                alert("notifyStopConditionTo:"+err.message);
			}
			
		});

		document.getElementById("btnIsOpen").addEventListener('click',function(){
			try{
				//alert(conSetted);
				asreader.isRfidOpened(receiveStopCon,receiveStopCon);
			}catch(err){
                alert("btnIsOpen:"+err.message);
			}
			
		});
		
		//document.getElementById("startReadTagsAndTid").addEventListener('click',function(){asreader.startReadTagsAndTid(null,null);});
//        document.getElementById("setOutputPowerLevelAndNotifyTo").addEventListener('click',function(){asreader.setOutputPowerLevelAndNotifyTo(listener,error,20);});

		document.getElementById("startReadTagsAndTid").addEventListener('click',function(){
            //asreader.setRfidEpcDataWithTidListener(setRfidEpcDataWithTidListener);
            asreader.setRfidEpcStringWithTidListener(rfidEpcStrTidReceived);
            asreader.startReadTagsAndTid(success, error);});
		
//        document.getElementById("setSelectParamAndNotifyTo").addEventListener('click',function(){
//            try{
//                /*
//                var hex = "FF";
//                for (var bytes = [], c = 0; c < hex.length; c += 2)
//                bytes.push(parseInt(hex.substr(c, 2), 16));
//                */
//                /*
//                var str = "3034";
//                  var buf = new ArrayBuffer(str.length*2); // 2 bytes for each char
//                  var bufView = new Uint16Array(buf);
//                  for (var i=0, strLen=str.length; i<strLen; i++) {
//                      bufView[i] = str.charCodeAt(i);
//                  }
//                  */
//                var msg = "30 38";
//                /*
//                var arr = new Uint8Array(msg.split(" "), function(byte) {
//                    return parseInt(byte, 16);
//                });
//                */
//                var arr = new Uint8Array(msg.split(' ').map(function(h) { return parseInt(h, 16) }));
//                var buffer = arr.buffer;
//
//                asreader.setSelectParamAndNotifyTo(listener,error,0x00,0x00,0x01,0x20,16,0x00,"30 35");
//            }catch(ex){
//                alert(ex);
//            }
//
//        });

		document.getElementById("clearall").addEventListener('click',function(){document.getElementById("datareceived").value = '';});
        
        document.getElementById("getCurrentBattery").addEventListener('click',function(){asreader.getCurrentBattery(success,error);});
            
		}catch(err){
            alert("getCurrentBattery:"+err.message);
		}
        
	},
	// Update DOM on a Received Event
	receivedEvent: function(id) {
		var parentElement = document.getElementById(id);
		var listeningElement = parentElement.querySelector('.listening');
		var receivedElement = parentElement.querySelector('.received');

		listeningElement.setAttribute('style', 'display:none;');
		receivedElement.setAttribute('style', 'display:block;');

		console.log('Received Event: ' + id);
	}
};

app.initialize();
